"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Lock = void 0;
const timeout_1 = require("../utils/timeout");
const LinkedPromise_1 = require("./LinkedPromise");
class Lock {
    constructor() {
        this.linkedPromise = new LinkedPromise_1.LinkedPromise();
    }
    acquire(timeout) {
        if (!timeout) {
            return this.linkedPromise.pushTask();
        }
        return timeout_1.throwIfTimeout(this.linkedPromise.pushTask(), timeout);
    }
    acquireImmediately(timeout) {
        if (!timeout) {
            return this.linkedPromise.pushTaskFront();
        }
        return timeout_1.throwIfTimeout(this.linkedPromise.pushTaskFront(), timeout);
    }
}
exports.Lock = Lock;
