"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.awaitIdle = exports.cancelHostIdleCallback = exports.requestHostIdleCallback = void 0;
const const_1 = require("../const");
try {
    exports.requestHostIdleCallback = window.requestIdleCallback;
    exports.cancelHostIdleCallback = window.cancelIdleCallback;
}
catch (e) { }
if (!exports.requestHostIdleCallback) {
    exports.requestHostIdleCallback = function (cb) {
        let start = Date.now();
        return setTimeout(function () {
            cb({
                didTimeout: false,
                timeRemaining: function () {
                    return Math.max(0, const_1.FRAME - (Date.now() - start));
                },
            });
        }, 1);
    };
    exports.cancelHostIdleCallback = clearTimeout;
}
function awaitIdle() {
    return new Promise((r) => exports.requestHostIdleCallback(r));
}
exports.awaitIdle = awaitIdle;
