"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.retry = void 0;
const delay_1 = require("./delay");
async function retry(callback, { sleepTimeout = 100, times = 3, } = {}) {
    while (times) {
        try {
            await callback();
            break;
        }
        catch (e) {
            times--;
            await delay_1.delay(sleepTimeout);
            if (times === 0) {
                throw e;
            }
        }
    }
}
exports.retry = retry;
