"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.throwIfTimeout = void 0;
const error_1 = require("../error");
const delay_1 = require("./delay");
function throwIfTimeout(promise, ms, msg) {
    if (ms == null) {
        return promise;
    }
    let done = false;
    promise.then(() => {
        done = true;
    });
    return Promise.race([
        promise,
        delay_1.delay(ms).then(() => {
            if (!done) {
                throw new error_1.TimeoutError(msg);
            }
        }),
    ]);
}
exports.throwIfTimeout = throwIfTimeout;
