"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.waitFor = void 0;
const const_1 = require("../const");
const error_1 = require("../error");
const delay_1 = require("./delay");
async function waitFor({ condition, interval = const_1.FRAME, timeout = const_1.MINUTE, }) {
    const startTime = +new Date();
    while (!condition()) {
        if (+new Date() - startTime > timeout) {
            throw new error_1.TimeoutError();
        }
        await delay_1.delay(interval);
    }
}
exports.waitFor = waitFor;
