export declare class Heap<T> {
    private array;
    private compare;
    constructor({ compare, key, }: {
        compare: (a: T, b: T) => number;
        key?: undefined;
    } | {
        key: (a: T) => string | number;
        compare?: undefined;
    });
    push(...arr: T[]): void;
    private _push;
    private _siftUp;
    pop(): T | undefined;
    private _siftDown;
    /**
     * It takes O(n) time
     * @param v
     */
    remove(v: T): void;
    [Symbol.iterator](): Generator<T | undefined, void, unknown>;
    get size(): number;
    get empty(): boolean;
    clear(): void;
}
