import { Heap } from "./Heap";
export class PriorityQueue {
    constructor(compare) {
        this.set = new Set();
        this.heap = new Heap({ compare });
    }
    push(item) {
        this.set.add(item);
        this.heap.push(item);
    }
    pop() {
        const ans = this.heap.pop();
        ans && this.set.delete(ans);
        return ans;
    }
    get size() {
        return this.heap.size;
    }
    get empty() {
        return this.heap.empty;
    }
    remove(item) {
        this.heap.remove(item);
        this.set.delete(item);
    }
    has(item) {
        return this.set.has(item);
    }
    clear() {
        this.set.clear();
        this.heap.clear();
    }
}
