import { throwIfTimeout } from "../utils/timeout";
import { LinkedPromise } from "./LinkedPromise";
export class Lock {
    constructor() {
        this.linkedPromise = new LinkedPromise();
    }
    acquire(timeout) {
        if (!timeout) {
            return this.linkedPromise.pushTask();
        }
        return throwIfTimeout(this.linkedPromise.pushTask(), timeout);
    }
    acquireImmediately(timeout) {
        if (!timeout) {
            return this.linkedPromise.pushTaskFront();
        }
        return throwIfTimeout(this.linkedPromise.pushTaskFront(), timeout);
    }
}
