import { IQueue } from "../../data-structure";
import { ErrorHandler } from "./ErrorHandler";
import { IInnerTask, ITask } from "./ITask";
export interface TaskQueueConfig {
    maxParallelNum?: number;
    taskInterval?: number | null;
    onError?: ErrorHandler;
    useIdleWorker?: boolean;
}
export declare class TaskQueue<T> {
    protected queue: IQueue<IInnerTask<T>>;
    private workers;
    private maxParallelNum;
    private taskInterval;
    private onError;
    private useIdleWorker;
    constructor({ maxParallelNum, taskInterval, onError, useIdleWorker, }?: TaskQueueConfig);
    push(task: (() => T) | ITask<T>): Promise<T>;
    start(): void;
    get runningNum(): number;
    pause(): void;
    destroy(): void;
}
