import { IQueue } from "../../../data-structure";
import { ErrorHandler } from "../ErrorHandler";
import { IInnerTask } from "../ITask";
export declare abstract class BaseTaskWorker {
    protected queue: IQueue<IInnerTask<any>>;
    protected onError: ErrorHandler;
    private _busy;
    private _destroyed;
    constructor(queue: IQueue<IInnerTask<any>>, onError: ErrorHandler);
    protected preExecute(): undefined | Promise<void>;
    protected postExecute(): undefined | Promise<void>;
    run(): Promise<void>;
    protected runTask(task: IInnerTask<unknown>): Promise<void>;
    get busy(): boolean;
    destroy(): void;
}
