import { awaitIdle } from "../../../utils/requestIdleCallback";
import { BaseTaskWorker } from "./BaseTaskWorker";
export class IdleWorker extends BaseTaskWorker {
    constructor() {
        super(...arguments);
        this.remaining = () => 0;
        this.estimatedExecutionTime = 1;
    }
    preExecute() {
        if (this.remaining() >= this.estimatedExecutionTime) {
            return;
        }
        return awaitIdle().then(({ timeRemaining }) => {
            this.remaining = timeRemaining;
        });
    }
    async runTask(task) {
        const startTime = Date.now();
        await super.runTask(task);
        const duration = Date.now() - startTime;
        if (duration > this.estimatedExecutionTime) {
            this.estimatedExecutionTime = duration;
        }
    }
}
