import { FRAME } from "../const";
export let requestHostIdleCallback;
export let cancelHostIdleCallback;
try {
    requestHostIdleCallback = window.requestIdleCallback;
    cancelHostIdleCallback = window.cancelIdleCallback;
}
catch (e) { }
if (!requestHostIdleCallback) {
    requestHostIdleCallback = function (cb) {
        let start = Date.now();
        return setTimeout(function () {
            cb({
                didTimeout: false,
                timeRemaining: function () {
                    return Math.max(0, FRAME - (Date.now() - start));
                },
            });
        }, 1);
    };
    cancelHostIdleCallback = clearTimeout;
}
export function awaitIdle() {
    return new Promise((r) => requestHostIdleCallback(r));
}
