import { delay } from "./delay";
export async function retry(callback, { sleepTimeout = 100, times = 3, } = {}) {
    while (times) {
        try {
            await callback();
            break;
        }
        catch (e) {
            times--;
            await delay(sleepTimeout);
            if (times === 0) {
                throw e;
            }
        }
    }
}
