import { TimeoutError } from "../error";
import { delay } from "./delay";
export function throwIfTimeout(promise, ms, msg) {
    if (ms == null) {
        return promise;
    }
    let done = false;
    promise.then(() => {
        done = true;
    });
    return Promise.race([
        promise,
        delay(ms).then(() => {
            if (!done) {
                throw new TimeoutError(msg);
            }
        }),
    ]);
}
